package cz.cuni.dsrg.sofa.netbeans.cdl;

import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CookieAction;

/** Action sensitive to some cookie that does something useful.
 *
 * @author  hnetynka
 */


public class CDLCompileAction extends CookieAction 
 {

   protected Class[] cookieClasses()
   {
      return new Class[] { CDLCompileAction.class };
   }

   protected int mode()
   {
      return MODE_EXACTLY_ONE;
     // return MODE_ALL;
   }


  protected void performAction(Node[] nodes)
  { 
    CDLCompileCookie cookie = (CDLCompileCookie) nodes[0].getCookie (CDLCompileCookie.class);

    if (cookie != null)
    cookie.compile();

  }
  public String getName () 
  {
    return NbBundle.getMessage(CDLCompileAction.class, "LBL_CDLCompile");
  }


  protected String iconResource () 
  {
    return "cz/cuni/dsrg/sofa/netbeans/resources/cdl/CDLCompileActionIcon.gif";
  }


  public HelpCtx getHelpCtx () 
  {
     return HelpCtx.DEFAULT_HELP;
    // If you will provide context help then use:
    // return new HelpCtx (CDLCompile2Action.class);
  }

 /** Perform special enablement check in addition to the normal one.*/
  protected boolean enable (Node[] nodes) 
  {
    return true;
  }

}
