/*
 * CDLCompilerTypeBeanInfo.java
 *
 * Created on 5. brezen 2001, 13:26
 */

package cz.cuni.dsrg.sofa.netbeans.cdl;

import org.openide.compiler.CompilerType;
import org.openide.util.NbBundle;

import java.awt.*;
import java.beans.BeanDescriptor;
import java.beans.BeanInfo;
import java.beans.IntrospectionException;
import java.beans.Introspector;

/** Description of the CDL compiler type.
 *
 * @author  hnetynka
 */


public class CDLCompilerTypeBeanInfo extends java.beans.SimpleBeanInfo 
{
    
    public BeanInfo[] getAdditionalBeanInfo () 
    {
      try 
      {
       return new BeanInfo[] 
       {
        Introspector.getBeanInfo (CompilerType.class)
       };
      } 
      catch (IntrospectionException ie) 
      {
        if (Boolean.getBoolean ("netbeans.debug.exceptions"))
            ie.printStackTrace ();
            return null;
      }
    }
    

    public BeanDescriptor getBeanDescriptor () 
    {
        // Here is where to include a customizer class if you have one:
        BeanDescriptor desc = new BeanDescriptor (CDLCompilerType.class);
        // Display name also serves as default for instances:
        desc.setDisplayName (NbBundle.getMessage (CDLCompilerTypeBeanInfo.class, "LBL_CDLCompilerType"));
        desc.setShortDescription (NbBundle.getMessage (CDLCompilerTypeBeanInfo.class, "HINT_CDLCompilerType"));
        return desc;
    }


    private static Image icon, icon32;


    public Image getIcon (int type) 
    {
        if (type == BeanInfo.ICON_COLOR_16x16 || type == BeanInfo.ICON_MONO_16x16) 
        {
            if (icon == null)
                icon = loadImage ("cz/cuni/dsrg/sofa/netbeans/resources/cdl/CDLCompilerIcon.gif");
            return icon;
        } 
        else 
        {
         if (icon32 == null)
           icon32 = loadImage ("cz/cuni/dsrg/sofa/netbeans/resources/cdl/CDLCompilerIcon32.gif");
           return icon32;
        }
    }
}
