package cz.cuni.dsrg.sofa.netbeans.settings;

import org.openide.util.NbBundle;

import java.awt.*;
import java.beans.*;

public class SofaSettingsBeanInfo extends SimpleBeanInfo
{
    public PropertyDescriptor[] getPropertyDescriptors() 
    {
        try 
        {
          PropertyDescriptor propone = new PropertyDescriptor ("Profile", SofaSettings.class);
           propone.setDisplayName (NbBundle.getMessage (SofaSettingsBeanInfo.class, "PROP_profile"));
           propone.setShortDescription (NbBundle.getMessage (SofaSettingsBeanInfo.class, "HINT_profile"));
           
           PropertyDescriptor proptwo = new PropertyDescriptor ("TIRHost", SofaSettings.class);
            proptwo.setDisplayName (NbBundle.getMessage (SofaSettingsBeanInfo.class, "PROP_tirhost"));
            proptwo.setShortDescription (NbBundle.getMessage (SofaSettingsBeanInfo.class, "HINT_tirhost"));
            
           PropertyDescriptor propthree = new PropertyDescriptor ("TIRPort", SofaSettings.class);
            propthree.setDisplayName (NbBundle.getMessage (SofaSettingsBeanInfo.class, "PROP_tirport"));
            propthree.setShortDescription (NbBundle.getMessage (SofaSettingsBeanInfo.class, "HINT_tirport"));

            PropertyDescriptor propfour = new PropertyDescriptor ("Gencodedir", SofaSettings.class, "getGencodedir", "setGencodedir");
             propfour.setDisplayName (NbBundle.getMessage (SofaSettingsBeanInfo.class, "PROP_generatedcodedir"));
             propfour.setShortDescription (NbBundle.getMessage (SofaSettingsBeanInfo.class, "HINT_generatedcodedir"));

           PropertyDescriptor propusep = new PropertyDescriptor ("UseProtocols", SofaSettings.class);
            propusep.setDisplayName (NbBundle.getMessage (SofaSettingsBeanInfo.class, "PROP_useprotocols"));
            propusep.setShortDescription (NbBundle.getMessage (SofaSettingsBeanInfo.class, "HINT_useprotocols"));
            propusep.setPropertyEditorClass (BoolPropEd.class);
            
           PropertyDescriptor proptestp = new PropertyDescriptor ("TestProtocols", SofaSettings.class);
            proptestp.setDisplayName (NbBundle.getMessage (SofaSettingsBeanInfo.class, "PROP_testprotocols"));
            proptestp.setShortDescription (NbBundle.getMessage (SofaSettingsBeanInfo.class, "HINT_testprotocols"));
            proptestp.setPropertyEditorClass (BoolPropEd.class);
            
           return new PropertyDescriptor[] { propone, proptwo, propthree, propfour, propusep, proptestp };
           
        } 
        catch (IntrospectionException ie) 
        {
         if(Boolean.getBoolean("netbeans.debug.exceptions"))
          ie.printStackTrace ();
         return null;
        }
    }


    private static Image icon, icon32;
    
    public Image getIcon (int type) 
    {
        if (type == BeanInfo.ICON_COLOR_16x16 || type == BeanInfo.ICON_MONO_16x16) 
        {
            if(icon == null)
             icon = loadImage ("cz/cuni/dsrg/sofa/netbeans/resources/settings/SofaSettingsIcon.gif");
            return icon;
        } 
        else 
        {
         if(icon32 == null)
          icon32 = loadImage ("cz/cuni/dsrg/sofa/netbeans/resources/settings/SofaSettingsIcon32.gif");
         return icon32;
        }
    }
    


    /** Boolean properties editor */
    public static class BoolPropEd extends PropertyEditorSupport 
    {
      private static final String[] tags = 
      {
          NbBundle.getMessage (SofaSettingsBeanInfo.class, "LBL_true"),
          NbBundle.getMessage (SofaSettingsBeanInfo.class, "LBL_false")
      };

      public String[] getTags () 
      {
            return tags;
      }

      public String getAsText () 
      {
        return tags[((Boolean) getValue ()).booleanValue () ? 0 : 1];
      }

      public void setAsText (String text) throws IllegalArgumentException 
      {
         if(tags[0].equals (text))
          setValue (Boolean.TRUE);
         else if (tags[1].equals (text))
          setValue (Boolean.FALSE);
         else
          throw new IllegalArgumentException ();
        }

    }
}
