package cz.cuni.dsrg.sofa.netbeans.settings;

import org.openide.util.NbBundle;

import java.awt.*;
import java.beans.*;

public class VDSettingsBeanInfo extends SimpleBeanInfo
{
    public PropertyDescriptor[] getPropertyDescriptors() 
    {
        try 
        {
          PropertyDescriptor propmod = new PropertyDescriptor ("Module", VDSettings.class);
           propmod.setDisplayName (NbBundle.getMessage (VDSettingsBeanInfo.class, "PROP_module"));
           propmod.setShortDescription (NbBundle.getMessage (VDSettingsBeanInfo.class, "HINT_module"));
           
           PropertyDescriptor propprov = new PropertyDescriptor ("Provider", VDSettings.class);
            propprov.setDisplayName (NbBundle.getMessage (VDSettingsBeanInfo.class, "PROP_provider"));
            propprov.setShortDescription (NbBundle.getMessage (VDSettingsBeanInfo.class, "HINT_provider"));
            

           return new PropertyDescriptor[] { propmod, propprov };
           
        } 
        catch (IntrospectionException ie) 
        {
         if(Boolean.getBoolean("netbeans.debug.exceptions"))
          ie.printStackTrace ();
         return null;
        }
    }


    private static Image icon, icon32;
    
    public Image getIcon (int type) 
    {
        if (type == BeanInfo.ICON_COLOR_16x16 || type == BeanInfo.ICON_MONO_16x16) 
        {
            if(icon == null)
             icon = loadImage ("cz/cuni/dsrg/sofa/netbeans/resources/settings/SofaSettingsIcon.gif");
            return icon;
        } 
        else 
        {
         if(icon32 == null)
          icon32 = loadImage ("cz/cuni/dsrg/sofa/netbeans/resources/settings/SofaSettingsIcon32.gif");
         return icon32;
        }
    }
    


    /** Boolean properties editor */
    public static class BoolPropEd extends PropertyEditorSupport 
    {
      private static final String[] tags = 
      {
          NbBundle.getMessage (SofaSettingsBeanInfo.class, "LBL_true"),
          NbBundle.getMessage (SofaSettingsBeanInfo.class, "LBL_false")
      };

      public String[] getTags () 
      {
            return tags;
      }

      public String getAsText () 
      {
        return tags[((Boolean) getValue ()).booleanValue () ? 0 : 1];
      }

      public void setAsText (String text) throws IllegalArgumentException 
      {
         if(tags[0].equals (text))
          setValue (Boolean.TRUE);
         else if (tags[1].equals (text))
          setValue (Boolean.FALSE);
         else
          throw new IllegalArgumentException ();
        }

    }
}
