package cz.cuni.dsrg.sofa.netbeans.tirbrowser;

import SOFA.SOFAnode.Made.TIR.Repository;
import SOFA.SOFAnode.Made.TIR.StateKind;
import SOFA.SOFAnode.Made.TIR.WorkRepository;
import org.openide.DialogDescriptor;
import org.openide.TopManager;
import org.openide.nodes.FilterNode;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.NodeAction;

/** Action sensitive to the node selection that does something useful.
 *
 * @author  hnetynka
 */


public class NewProfileAction extends NodeAction 
{
   RepositoryCookie rc;

    protected void performAction (Node[] nodes) 
    {
       FilterNode fn, fn2;

        NewProfilePanel panel = new NewProfilePanel();
        DialogDescriptor dd = new DialogDescriptor(panel, getName());
        TopManager tp = TopManager.getDefault();
        java.awt.Dialog d = tp.createDialog(dd);
        d.pack();
        d.show();
        
        if (dd.getValue() == DialogDescriptor.OK_OPTION) 
        {
            if (panel.getProfileName().length() == 0) 
            {
                MiscHelps.message("Can't create profile with this name.");
                return;
            }


            try
            {
                fn = (FilterNode) nodes[0].getParentNode();
                fn2= (FilterNode) nodes[0];

                  RepositoryCookie rc = (RepositoryCookie) fn.getCookie(RepositoryCookieImpl.class);
                Repository tir = rc.getTIR();


                if (tir.get_state().value() == StateKind.sk_work)
                {
                   InstrumentalCookie ic= (InstrumentalCookie) fn2.getCookie(TIRProfilesRefresh.class);

                   OpenedWorkRepository owr = (OpenedWorkRepository) org.openide.util.SharedClassObject.findObject(OpenedWorkRepository.class);
                   owr.getRepository().getProfiles().create_profile(panel.getProfileName());   //Objekt typu ManageProfiles
                   ic.setTIRProfile(owr.getRepository().getProfiles());

                }
                else 
                {  // normal repository
                    tir = tir.beginChanges(null);
                    tir.getProfiles().create_profile(panel.getProfileName());
                    ((WorkRepository) tir).commit();
                }

                fn=  (FilterNode) nodes[0];
                ((RefreshableNode)fn.getCookie(TIRProfilesRefresh.class)).refresh();
            } 

            catch (java.rmi.RemoteException e)
            {
              MiscHelps.exception(e);
            } 

            catch (SOFA.SOFAnode.Made.TIR.TIRExceptLock e)
            {
                MiscHelps.message("Can't create profile. TIR is locked.");
            } 

            catch (SOFA.SOFAnode.Made.TIR.TIRExceptCreate e)
            {
                MiscHelps.message("Can't create profile. "+e.getMessage());
            } 

            catch (SOFA.SOFAnode.Made.TIR.TIRExceptCommit e)
            {
                MiscHelps.message("Can't create profile. "+e.getMessage());
            }
        }
    }

    
    
    protected boolean enable (Node[] nodes) 
    {
        // return  nodes.length == 1 && nodes[0] instanceof TIRProfilesNode;
        return true;                                                           // changed by top
    }


    public String getName () 
    {
        return NbBundle.getMessage(NewProfileAction.class, "LBL_NewProfileAction");
    }


    protected String iconResource () 
    {
        return "cz/cuni/dsrg/sofa/netbeans/resources/tirbrowser/NewProfileActionIcon.gif";
    }


    public HelpCtx getHelpCtx () 
    {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (NewProfileAction.class);
    }



    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
    protected void initialize () {
	super.initialize ();
     * putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (NewProfileAction.class, "HINT_Action"));
    }
    */

}
