package cz.cuni.dsrg.sofa.netbeans.tirbrowser;

import SOFA.SOFAnode.Made.TIR.Repository;

/**
 * Created by IntelliJ IDEA.
 * User: PhD
 * Date: 5.4.2003
 * Time: 16:26:57
 * To change this template use Options | File Templates.
 */
public class RepositoryCookieImpl implements RepositoryCookie
{
    int port;
    String host;
    boolean work;
    SOFA.SOFAnode.Made.TIR.Repository tir;
    RepositoryRootNode assocNode;

   public RepositoryCookieImpl (int port, String host, SOFA.SOFAnode.Made.TIR.Repository tir, RepositoryRootNode an)
   {
       this.port = port;
       this.host = host;
       this.tir = tir;
       work = false;
       assocNode= an;
   }

    public int getTIRPort()
    {
        return this.port;
    }

    public String getTIRHost()
    {
        return this.host;
    }

    public String getProfileName()
    {
        if (work)
        {
            try
            {
                return ((SOFA.SOFAnode.Made.TIR.WorkRepository) tir).profile().name();
            }
            catch (Exception e)
            {
                return "can't get profile name";
            }
        }
        else
        {
            return "no profile";
        }
    }

    public void setWork(SOFA.SOFAnode.Made.TIR.Repository rep)
    {
        work = true;
        tir = rep;
        assocNode.setIconBase ("cz/cuni/dsrg/sofa/netbeans/resources/tirbrowser/WorkRepositoryRootNodeIcon");
        RepositoryRootChildren ch = assocNode.getRepositoryRootChildren();
        ch.remove(ch.getNodes());
        ch.removeNotify();
        assocNode.createChildren();
    }


    public void unsetWork(SOFA.SOFAnode.Made.TIR.Repository rep)
    {
        work = false;
        tir = rep;
        assocNode.setIconBase ("cz/cuni/dsrg/sofa/netbeans/resources/tirbrowser/RepositoryRootNodeIcon");
        RepositoryRootChildren ch = assocNode.getRepositoryRootChildren();
        ch.remove(ch.getNodes());
        ch.removeNotify();
        assocNode.createChildren();

    }

    public boolean isWork()
    {
        return work;
    }

   public SOFA.SOFAnode.Made.TIR.ManageRepository getManageRepository() throws java.rmi.RemoteException
    {
        return tir.getManage();
    }


    public void destroy () throws java.io.IOException
    {
     if (work)
     {
        ((SOFA.SOFAnode.Made.TIR.WorkRepository)tir).abort();
        OpenedWorkRepository owr = (OpenedWorkRepository) org.openide.util.SharedClassObject.findObject(OpenedWorkRepository.class);
        owr.setRepository(null);
        owr.setOldrepository(null);
        owr.setRepnode(null);
     }
   }

    public Repository getTIR()
    {
        return tir;
    }

public RepositoryRootChildren getRepositoryRootChildren()
{
    return assocNode.getRepositoryRootChildren();
}


}


