package cz.cuni.dsrg.sofa.netbeans.tirbrowser;

import org.openide.nodes.Children;
import org.openide.nodes.Node;

import java.util.Collection;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

/** List of children of a containing node.
 * Remember to document what your permitted keys are!
 *
 * @author Petr Hnetynka
 */


public class TIRContainerChildren extends Children.Keys 
{

    /** Optional holder for the keys, to be used when changing them dynamically. */
    protected List myKeys;

    public TIRContainerChildren () 
    {
        myKeys = null;
        //setBefore(true);
    }

    protected void addNotify () 
    {
        if (myKeys != null) return;
        myKeys = new LinkedList ();
        // add whatever keys you need
        setKeys (myKeys);
    }

    protected void removeNotify () 
    {
        myKeys = null;
        setKeys (Collections.EMPTY_SET);
    }


    protected Node[] createNodes (Object key) 
    {
        // interpret your key here...usually one node generated, but could be zero or more
        //MiscHelps.message("aaa");
        try 
        {
            TIRContainerKey kk = (TIRContainerKey) key;
            String name = ((TIRContainerKey) key).name;
            Node[] result = new Node [kk.obj.length];
            for (int i=0;i<kk.obj.length;i++) 
            {
                if (kk.obj[i] instanceof SOFA.SOFAnode.Made.TIR.Container)
                    result[i] = new TIRContainerNode((SOFA.SOFAnode.Made.TIR.Container) kk.obj[i], null);
                else
                    result[i] = new TIRContainedNode(kk.obj[i], null);
            }
            return result;
        } 
        catch (java.rmi.RemoteException e) 
        {
        }
        return null;
    }

    
    /** Optional accessor method for the keys, for use by the container node or maybe subclasses. */
    
    protected void addKey (Object newKey) 
    {
	      // Make sure some keys already exist:
	      addNotify ();
	      myKeys.add (newKey);
	      // Ensure that the node(s) is displayed:
	      refreshKey (newKey);
    }
    

    /** Optional accessor method for keys, for use by the container node or maybe subclasses. */
    
    protected void setMyKeys (Collection keys) 
    {
	myKeys = new LinkedList ();
	myKeys.addAll (keys);
	super.setKeys (keys);
    }
    

    // Could also write e.g. removeKey to be used by the nodes in this children.
    // Or, could listen to changes in their status (NodeAdapter.nodeDestroyed)
    // and automatically remove them from the keys list here. Etc.
/*
    protected boolean addChild (Object newNode) 
    {
        addNotify ();
        String key =((Node)newNode).getName();
        if (myKeys.contains(key))
            return false;
	      myKeys.add (key);
        add(new Node[] { (Node)newNode} ); 
	      refreshKey (newNode);
        return true;
    }
  */  
    /** if this is unique key */
    /*
    protected boolean testChildKey(String newKey) 
    {
        addNotify ();
        return !myKeys.contains(newKey);
    }
     */
}
