package cz.cuni.dsrg.sofa.netbeans.visualdesigner.designer;

import cz.cuni.dsrg.sofa.netbeans.tirbrowser.MiscHelps;
import cz.cuni.dsrg.sofa.netbeans.visualdesigner.explorer.nodes.ComponentNode;
import cz.cuni.dsrg.sofa.netbeans.visualdesigner.objects.Component;
import org.openide.nodes.Node;
import org.openide.windows.Mode;
import org.openide.windows.TopComponent;
import org.openide.windows.WindowManager;
import org.openide.windows.Workspace;

import java.awt.*;

/**
 * This is a helper class to implement the window for the component designer.
 *
 * @author Michael Cifka
 */
public class ArchitectureWindow extends TopComponent
{
    public ArchitectureWindow()
    {
        setCloseOperation(CLOSE_LAST);
        setLayout(new BorderLayout());
        setBackground(Color.pink);
        editor = new ArchitectureEditor(this);
        add(editor);
    }

    public static ArchitectureWindow getDefault()
    {
        return defaultInstance;
    }

    public void setEditedComponent(ComponentNode node)
    {
        this.node = node;
        setName(node.getComponent().getName());
        editor.setContents(node, null);
    }

    public ComponentNode getEditedComponent()
    {
        return node;
    }

    public void moveToParent()
    {
        Node pn = node.getParentNode();
        if(pn instanceof ComponentNode)
            setEditedComponent((ComponentNode) pn);
    }

    public void moveToInstance(Component c)
    {
        Node[] ns = node.getChildren().getNodes();
        if(ns != null)
            for(int i = 0; i < ns.length; i++)
                if(((ComponentNode) ns[i]).getComponent() == c)
                {
                    setEditedComponent((ComponentNode) ns[i]);
                    return;
                }
    }

    public void open(Workspace workspace)
    {
///      MiscHelps.message("OpenArchitectureWindow1");
        if(isOpened())
            return;
///      MiscHelps.message("OpenArchitectureWindow2");

        WindowManager dwm= WindowManager.getDefault();
        Workspace ws;
        Mode VDmode;

///      MiscHelps.message("OpenArchitectureWindow3");

        Workspace[] w= dwm.getWorkspaces();
        if(workspace == null)
        {
          if((workspace= dwm.findWorkspace("SOFA"))==null)
          {
            MiscHelps.message("THE SOFA WORSPACE DOESN'T EXIST");
            workspace= dwm.getCurrentWorkspace();
          }
          else  workspace.activate();
        }

///    MiscHelps.message("OpenArchitectureWindow4");

/**           ws= dwm.createWorkspace("SOFAVisualDesigner","SOFA Visual Designer");
          Workspace[] wsss= dwm.getWorkspaces();
          Workspace[] wss= new Workspace[wsss.length+1];
          for(int i=0; i<wsss.length; i++)
           wss[i]= wsss[i];
         wss[wsss.length]=ws;
         dwm.setWorkspaces(wss);


        }
        else
        {
           Object[] modes= workspace.getModes().toArray();
           for(int i=0; i<modes.length; i++) MiscHelps.message("Mod: "+((Mode) modes[i]).getName());

            TopComponent myComp= new MyTopComponent(null,null);
            Mode m= ws.findMode("editor");

            m.dockInto(myComp);

            TopComponent[] tc= m.getTopComponents();
            MiscHelps.message("VypisTopComponent:");
            for(int i=0; i<tc.length; i++)
            {
              MiscHelps.message("Top Komponenta: "+tc[i].getName());
            }


        if((VDmode= ws.findMode("Designer"))== null)
        {
          VDmode= ws.createMode("Designer", "Designer", null);
        }
        ws.activate();
        TopComponent myComp= new MyTopComponent(null,null);
        VDmode.dockInto(myComp);
        myComp.open();
        myComp.requestFocus();

***/

        Mode mode = workspace.findMode("editor");
        if(mode == null)
        {
            mode = workspace.createMode("editor", "Editor", null);
            mode.setBounds(new java.awt.Rectangle(0, 0, 510, 435));
        }
/// MiscHelps.message("OpenArchitectureWindow5");

        TopComponent[] tc= mode.getTopComponents();
        for(int i=0; i<tc.length; i++)
          if(tc[i].getName().equalsIgnoreCase(this.getName()))
            tc[i].close();  //the window is closed if it already exists
        mode.dockInto(this);


        //*        if(tc!=null)
        {
///            MiscHelps.message(Integer.toString(tc.length));
//*             for(int i=0; i<tc.length; i++)
//*             tc[i].close();
          //  if(tc[i].getName().equalsIgnoreCase("Welcome")) tc[i].close();
        }
/// MiscHelps.message("OpenArchitectureWindow6");
        /// MiscHelps.message("OpenArchitectureWindow7");
       super.open(workspace);

/// MiscHelps.message("OpenArchitectureWindow8");
        //Debug.print(mode.getBounds().toString());
        }

    public Dimension getPreferredSize()
    {
        return new Dimension(510, 435);
    }

    private static ArchitectureWindow defaultInstance = new ArchitectureWindow();
    private ArchitectureEditor editor;
    private ComponentNode node;
}

