package cz.cuni.dsrg.sofa.netbeans.visualdesigner.designer;

import java.awt.*;

/**
 * A helper class to hold the visual layout data.<p>
 *
 * This class can be persisted using the Java Object Serialization.
 *
 * @author Michael Cifka
 */
public class Layout implements java.io.Serializable
{

    private final Point standaloneLocation = new Point();
    private final Point embeddedLocation = new Point();
    private final Dimension standaloneSize = new Dimension();
    private final Dimension embeddedSize = new Dimension();

    // standalone location

    public Point getStandaloneLocation()
    {
        return new Point(standaloneLocation);
    }

    public Point getStandaloneLocation(Point rv)
    {
        if(rv == null)
            return getStandaloneLocation();
        rv.x = standaloneLocation.x;
        rv.y = standaloneLocation.y;
        return rv;
    }

    public void setStandaloneLocation(Point p)
    {
        setStandaloneLocation(p.x, p.y);
    }

    public void setStandaloneLocation(int x, int y)
    {
        standaloneLocation.x = x;
        standaloneLocation.y = y;
    }

    // embedded location

    public Point getEmbeddedLocation()
    {
        return new Point(embeddedLocation);
    }

    public Point getEmbeddedLocation(Point rv)
    {
        if(rv == null)
            return getEmbeddedLocation();
        rv.x = embeddedLocation.x;
        rv.y = embeddedLocation.y;
        return rv;
    }

    public void setEmbeddedLocation(Point p)
    {
        setEmbeddedLocation(p.x, p.y);
    }

    public void setEmbeddedLocation(int x, int y)
    {
        embeddedLocation.x = x;
        embeddedLocation.y = y;
    }

    // standalone size

    public Dimension getStandaloneSize()
    {
        return new Dimension(standaloneSize);
    }

    public Dimension getStandaloneSize(Dimension rv)
    {
        if(rv == null)
            return getStandaloneSize();
        rv.width = standaloneSize.width;
        rv.width = standaloneSize.height;
        return rv;
    }

    public void setStandaloneSize(Dimension d)
    {
        setStandaloneSize(d.width, d.height);
    }

    public void setStandaloneSize(int width, int height)
    {
        standaloneSize.width = width;
        standaloneSize.height = height;
    }

    // embedded size

    public Dimension getEmbeddedSize()
    {
        return new Dimension(embeddedSize);
    }

    public Dimension getEmbeddedSize(Dimension rv)
    {
        if(rv == null)
            return getEmbeddedSize();
        rv.width = embeddedSize.width;
        rv.width = embeddedSize.height;
        return rv;
    }

    public void setEmbeddedSize(Dimension d)
    {
        setEmbeddedSize(d.width, d.height);
    }

    public void setEmbeddedSize(int width, int height)
    {
        embeddedSize.width = width;
        embeddedSize.height = height;
    }

}
