package cz.cuni.dsrg.sofa.netbeans.visualdesigner.designer;

import java.awt.*;

/**
 * An interface to be implemented by components that should be manipulated
 * visually in the component designer. By implementig this interface, the
 * components can also express the ability to be moved and resized or review
 * the commands to be moved and resized.
 *
 * @author Michael Cifka
 */
public interface VisualDesign
{
    public boolean canMove();

    public boolean canResize(int direction);

    public Rectangle reviewMove(Rectangle before, Rectangle after);

    public Rectangle reviewResize(Rectangle before, Rectangle after);
}