package cz.cuni.dsrg.sofa.netbeans.visualdesigner.explorer.actions;

import cz.cuni.dsrg.sofa.netbeans.visualdesigner.explorer.cookies.ComponentCookie;
import cz.cuni.dsrg.sofa.netbeans.visualdesigner.objects.Component;
import cz.cuni.dsrg.sofa.netbeans.visualdesigner.typemanager.TypeManager;
import cz.cuni.dsrg.sofa.netbeans.visualdesigner.types.Repository;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.actions.CookieAction;

/**
 * This action resets the component project, by deleting both the component and
 * the type information.
 *
 * @author Michael Cifka
 */
public class ActResetComponent extends CookieAction
{
    protected int mode()
    {
        return CookieAction.MODE_EXACTLY_ONE;
    }

    protected Class[] cookieClasses()
    {
        return new Class[]{ComponentCookie.class};
    }

    public String getName()
    {
        return "Reset Component";
    }

    public HelpCtx getHelpCtx()
    {
        return HelpCtx.DEFAULT_HELP;
    }


    protected void performAction(Node[] nodes)
    {
        Node node = nodes[0];
        ComponentCookie cookie = (ComponentCookie) node.getCookie(ComponentCookie.class);
        Component component = cookie.getComponent();
        component.setType(null);
        component.setImplementation(null);

        Repository rep = component.getRepository();
        rep.clean();

        TypeManager manager = TypeManager.get(rep);
        manager.refresh();

        component.setType(rep.createFrameType());
        component.createImplementation();
    }
}
