package cz.cuni.dsrg.sofa.netbeans.visualdesigner.explorer.properties;

import cz.cuni.dsrg.sofa.netbeans.visualdesigner.types.Repository;
import org.openide.nodes.PropertySupport;

import java.beans.PropertyEditor;

/**
 * Using this property, the developer can provide a custom source code
 * for the project. The code is entered via the provided text editting
 * window and it will be included at the beginning of the generated CDL file.
 *
 * @author Michael Cifka
 */
public class PropCustomCode extends PropertySupport.ReadWrite
{
    private Repository repository;

    public PropCustomCode(Repository repository)
    {
        super("customSource", String.class, "Custom Code", null);
        setValue("canEditAsText", Boolean.FALSE);
        setValue("changeImmediate", Boolean.FALSE);
        this.repository = repository;
    }

    public Object getValue()
    {
        return repository.getCustomCode();
    }

    public void setValue(Object val)
    {
        repository.setCustomCode((String) val);
    }

    public PropertyEditor getPropertyEditor()
    {
        return new cz.cuni.dsrg.sofa.netbeans.visualdesigner.text.SourceCodeEditor();
    }
}