package cz.cuni.dsrg.sofa.netbeans.visualdesigner.explorer.properties;

import cz.cuni.dsrg.sofa.netbeans.visualdesigner.objects.Component;
import org.openide.nodes.PropertySupport;

/**
 * Using this property, the developer can specify a name for the file
 * where the code of the compoent will be generated. This property
 * can be also left empty, assuming that the framework will create
 * a file name automatically.
 *
 * @author Michael Cifka
 */

public class PropSourceFile extends PropertySupport.ReadWrite
{
    private Component component;
    private static final String NOT_SPECIFIED = "(not specified)";

    public PropSourceFile(Component component)
    {
        super("source", String.class, "Source File", null);
        setValue("canEditAsText", Boolean.TRUE);
        this.component = component;
    }


    public Object getValue()
    {
        String s = component.getSource();
        if(s == null)
            return NOT_SPECIFIED;
        else
            return s;
    }

    public void setValue(Object val)
    {
        String s = (String) val;
        if(s.equals("") || s.equals("NOT_SPECIFIED"))
            component.setSource(null);
        else
            component.setSource(s);
    }
}